package com.jesuscb.footcoach.model.firebase.auth

import com.google.android.gms.tasks.Task
import com.google.firebase.auth.AuthResult
import com.google.firebase.auth.FirebaseUser
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor

class AuthInteractor : IAuthInteractor {

    //login in firebase
    override fun login(user: String, pass: String) : Task<AuthResult> {
        return FirebaseInteractor.getAuthInstance().signInWithEmailAndPassword(user, pass)
    }

    //exist user session actived?
    override fun sessionActived(): Boolean {
       if(FirebaseInteractor.getAuthInstance().currentUser!=null) return true else return false
    }

    //return firebaseUser instance
    override fun getCurrentUser(): FirebaseUser? {
        return FirebaseInteractor.getAuthInstance().currentUser
    }

    //sign out session
    override fun signOut(){
        if(sessionActived()){
            FirebaseInteractor.getAuthInstance().signOut()
        }
    }
}