package com.jesuscb.footcoach.model.firebase.player

import com.google.firebase.database.ValueEventListener
import com.jesuscb.footcoach.model.Exercise
import com.jesuscb.footcoach.model.Player
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor

class PlayerInteractor : IPlayerInteractor {

    private var playersReference = FirebaseInteractor.getUsersReference().child(FirebaseInteractor.getUserUID()).child("players")

    override fun getPlayers(playersListener: ValueEventListener) {
        playersReference.addListenerForSingleValueEvent(playersListener)
    }

    override fun getPlayers(players:ArrayList<String>,playersListener: ValueEventListener) {
        for (id: String in players) {
            playersReference.child(id).addListenerForSingleValueEvent(playersListener)
        }
    }

    override fun getPlayer(id: String, playerListener: ValueEventListener) {
        playersReference.child(id).addListenerForSingleValueEvent(playerListener)
    }

    override fun updatePlayer(player: Player) {
        playersReference.child(player.id_player).setValue(player)
    }

    override fun savePlayer(player: Player) {
        val key = playersReference.push().key
        player.id_player = key
        playersReference.child(key).setValue(player)
    }

    override fun savePlayers(players: MutableList<Player>) {
        players.forEach {
            val key = playersReference.push().key
            it.id_player = key
            playersReference.child(key).setValue(it)
        }
    }

    override fun deletePlayer(id_player: String) {
        playersReference.child(id_player).removeValue()
    }
}