package com.jesuscb.footcoach.model.firebase.register

import com.google.android.gms.tasks.Task
import com.google.firebase.auth.AuthResult
import com.jesuscb.footcoach.model.User
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor
import org.apache.commons.codec.binary.Hex
import org.apache.commons.codec.digest.DigestUtils

class RegisterInteractor : IRegisterInteractor {

    //register user in FirebaseAuthentication
    override fun registerUser(user: User): Task<AuthResult> {
        return FirebaseInteractor.getAuthInstance().createUserWithEmailAndPassword(user.email, user.pass)
    }

    //save a user data
    override fun saveUser(user: User) {
        user.pass = String(Hex.encodeHex(DigestUtils.md5(user.pass)))
        FirebaseInteractor.getUsersReference().child(user.uid).setValue(user)
    }


}