package com.jesuscb.footcoach.model.firebase.training

import com.google.firebase.database.ChildEventListener
import com.google.firebase.database.ValueEventListener
import com.jesuscb.footcoach.model.Exercise
import com.jesuscb.footcoach.model.Player
import com.jesuscb.footcoach.model.Training

interface ITrainingInteractor {

    fun getTrainings(trainingListener: ValueEventListener)

    fun getTraining(id: String, trainingListener: ValueEventListener)

    fun saveTraining(training: Training): Training

    fun updateTraining(training: Training)

    fun deleteExerciseFromTraining(exerciseId: String, trainingId: String)

    fun deletePlayerFromTraining(playerId: String, trainingId: String)

    fun addSelectedExercisesToTraining(selectedExercises : ArrayList<Exercise>, trainingId: String)

    fun addSelectedPlayersToTraining(selectedPlayers: ArrayList<Player>, trainingId: String)

    fun deleteTraining(training: Training)
}