package com.jesuscb.footcoach.presenter

import com.google.android.gms.tasks.OnCompleteListener
import com.jesuscb.footcoach.model.firebase.auth.IAuthInteractor
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor
import com.jesuscb.footcoach.view.login.LoginView

class LoginPresenter(val loginView: LoginView) {

    private var authInteractor: IAuthInteractor =FirebaseInteractor.authInteractor

    fun start() {
        if(authInteractor.sessionActived()){
            loginView.loginSucessfull()
        }else{
            loginView.initialise()
        }
    }

    fun login(user: String, pass: String) {
        loginView.showProgressBar(true)
        authInteractor.login(user,pass).addOnCompleteListener(OnCompleteListener { task ->
            if(task.isSuccessful){
                loginView.showProgressBar(false)
                loginView.loginSucessfull()
            }else{
                loginView.showProgressBar(false)
                loginView.showLoginErrorToast()
            }
        })
    }
}