package com.jesuscb.footcoach.presenter

import com.google.android.gms.tasks.OnCompleteListener
import com.jesuscb.footcoach.model.User
import com.jesuscb.footcoach.model.firebase.auth.IAuthInteractor
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor
import com.jesuscb.footcoach.model.firebase.register.IRegisterInteractor
import com.jesuscb.footcoach.view.register.RegisterView

class RegisterPresenter(val registerView: RegisterView) {

    private var authInteractor: IAuthInteractor = FirebaseInteractor.authInteractor
    private var registerInteractor: IRegisterInteractor = FirebaseInteractor.registerInteractor

    fun start() {
        registerView.initialise()
    }

    fun registerUser(user: User) {
        registerView.showProgressBar(true)
        registerInteractor.registerUser(user).addOnCompleteListener(OnCompleteListener { task ->
            if (task.isSuccessful) {
                val uid = authInteractor.getCurrentUser()!!.uid
                user.uid = uid
                registerInteractor.saveUser(user)
                registerView.showProgressBar(false)
                registerView.registerSucessfull()

            } else {
                registerView.showProgressBar(false)
                registerView.showRegisterErrorToast()
            }
        })
    }
}