package com.jesuscb.footcoach.presenter.match

import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import com.jesuscb.footcoach.model.Match
import com.jesuscb.footcoach.model.firebase.core.FirebaseInteractor
import com.jesuscb.footcoach.model.firebase.match.IMatchInteractor
import com.jesuscb.footcoach.view.match.MatchCRUDView


class MatchCRUDPresenter(val matchCRUDView: MatchCRUDView) {
    private var matchInteractor: IMatchInteractor = FirebaseInteractor.matchInteractor
    private lateinit var matchListener: ValueEventListener

    fun start() {
        matchCRUDView.initialise()
    }

    fun addOrUpdateMatch(match: Match) {
        if (match.id_match.isNullOrBlank()) {
            matchInteractor.saveMatch(match)
        } else {
            matchInteractor.updateMatch(match)
        }
        matchCRUDView.matchModified()
    }

    fun getMatch(id: String) {
        createMatchListener()
        matchInteractor.getMatch(id, matchListener)
    }

    //Crea el listener para los partidos
    private fun createMatchListener() {
        matchListener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                var match: Match? = dataSnapshot.getValue<Match>(Match::class.java)
                matchCRUDView.updateDetailsMatch(match!!)
                //exerciseDetailView.hideProgressBar()
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("loadTrainig:onCancelled ${databaseError.toException()}")
            }
        }
    }
}