package com.jesuscb.footcoach.view.core

import com.jesuscb.footcoach.model.Match
import com.jesuscb.footcoach.model.Training
import org.joda.time.DateTime
import org.joda.time.format.DateTimeFormat

object Utils {

    fun parseStringToDateTime(dateString: String): DateTime {
        val formatter = DateTimeFormat.forPattern("dd/MM/yyyy")
        return formatter.parseDateTime(dateString)
    }

    fun parseStringToDateTimeHour(dateString: String, hourString: String): DateTime {
        val formatter = DateTimeFormat.forPattern("dd/MM/yyyy HH:mm")
        return formatter.parseDateTime(dateString + " " + hourString)
    }

    class CompareTrainingsDatesDescending {
        companion object : Comparator<Training> {
            override fun compare(t1: Training, t2: Training): Int = (parseStringToDateTime(t2.date).compareTo(parseStringToDateTime(t1.date)))
        }
    }

    class CompareTrainingsDatesAscending {
        companion object : Comparator<Training> {
            override fun compare(t1: Training, t2: Training): Int = (parseStringToDateTime(t1.date).compareTo(parseStringToDateTime(t2.date)))
        }
    }

    class CompareMatchsDatesDescending {
        companion object : Comparator<Match> {
            override fun compare(m1: Match, m2: Match): Int = (parseStringToDateTime(m2.date).compareTo(parseStringToDateTime(m1.date)))
        }
    }

    class CompareMatchsDatesAscending {
        companion object : Comparator<Match> {
            override fun compare(m1: Match, m2: Match): Int = (parseStringToDateTime(m1.date).compareTo(parseStringToDateTime(m2.date)))
        }
    }
}