package com.jesuscb.footcoach.view.exercise

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.MenuItem
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Exercise
import com.jesuscb.footcoach.view.core.BaseActivity
import com.jesuscb.footcoach.view.core.IExerciseListToActivity
import kotlinx.android.synthetic.main.activity_exercise_add_to_training.*

class ExerciseAddToTraining : BaseActivity(), IExerciseListToActivity {

    private lateinit var selectedExercisesIds: ArrayList<String>
    private var selectedExercises: ArrayList<Exercise> = arrayListOf()
    var exerciseFragment: ExerciseListFragment? = null

    companion object {

        private val ARG_PARAM_EXERCISES_SELECTED = "exerciseIDS"
        val RETURN_PARAM_EXERCISES_SELECTED: String = "selectedExerciseIDS"

        fun newIntent(context: Context, exercises: ArrayList<String>): Intent {
            val intent = Intent(context, ExerciseAddToTraining::class.java)
            intent.putStringArrayListExtra(ARG_PARAM_EXERCISES_SELECTED, exercises)
            return intent
        }
    }

    /**
     *
     */
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_exercise_add_to_training)
        setSupportActionBar(add_exercise_to_training_toolbar)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        selectedExercisesIds = intent.getStringArrayListExtra(ARG_PARAM_EXERCISES_SELECTED)
        exerciseFragment = ExerciseListFragment.newInstanceSelectedExercises(2, selectedExercisesIds)

        addFragment(exerciseFragment!!, list_exercises.id)
        btn_add_exercises.setOnClickListener { returnExercisesToDetailActivity() }
        //exerciseFragment!!.removeExercisesSelected(exerciseSelected)
    }

    override fun informExercisesIgnored(exercisesToIgnore: ArrayList<Exercise>) {
        selectedExercises.addAll(exercisesToIgnore)
    }

    private fun returnExercisesToDetailActivity() {
        val returnIntent = Intent()
        selectedExercises.addAll(exerciseFragment!!.getExercisesFromAdapter())
        returnIntent.putExtra(RETURN_PARAM_EXERCISES_SELECTED, selectedExercises)
        setResult(Activity.RESULT_OK, returnIntent)
        finish()
    }


    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        // Handle item selection
        backToDetails()
        return true
    }

    override fun onBackPressed() {
        backToDetails()
    }

    private fun backToDetails() {
        val returnIntent = Intent()
        setResult(Activity.RESULT_CANCELED, returnIntent)
        finish()
    }

    override fun deleteExercise(exercise: String) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun addExercisesToTraining(exercisesIds: ArrayList<String>) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }
}
