package com.jesuscb.footcoach.view.match

import android.graphics.Color
import android.support.v7.widget.CardView
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Match

internal class MatchAdapter(var matchList: MutableList<Match>, val matchListFragment: MatchListFragment) : RecyclerView.Adapter<MatchAdapter.MatchViewHolder>() {

    override fun onBindViewHolder(holder: MatchViewHolder, position: Int) {
        holder.date.text = matchList[position].date
        holder.rival.text = matchList[position].rival

        holder.itemView.setOnClickListener { matchListFragment.viewDetailsMatch(matchList[position].id_match) }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MatchViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.adapter_match, parent, false)
        if (viewType  == 0) {
            v.findViewById<CardView>(R.id.card_match_list).setCardBackgroundColor(Color.parseColor("#FFE9E9"))
        } else {
            v.findViewById<CardView>(R.id.card_match_list).setCardBackgroundColor(Color.parseColor("#FFF9F9"))
        }
        return MatchViewHolder(v);
    }

    override fun getItemViewType(position: Int): Int {
        return position%2
    }

    override fun getItemCount(): Int {
        return matchList.size
    }

    internal class MatchViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val date = itemView.findViewById<TextView>(R.id.day_match)
        val rival = itemView.findViewById<TextView>(R.id.rival)

    }

    fun setItems(items: MutableList<Match>) {
        matchList = items
    }
}