package com.jesuscb.footcoach.view.player

import android.graphics.Color
import android.support.v7.widget.CardView
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Player

internal class PlayerAdapter(var playerList: MutableList<Player>, val playerListFragment: PlayerListFragment) : RecyclerView.Adapter<PlayerAdapter.PlayerViewHolder>() {

    override fun onBindViewHolder(holder: PlayerViewHolder, position: Int) {
        holder.dorsal.text = playerList[position].numDorsal.toString()
        holder.name.text = playerList[position].name.plus(" ").plus(playerList[position]. surname)
        holder.demarcation.text=playerListFragment.getDemarcationValueFromKey(playerList[position].demarcation)

        holder.itemView.setOnClickListener { playerListFragment.viewDetailsPlayer(playerList[position].id_player) }
        holder.itemView.setOnLongClickListener{playerListFragment.deletePlayer(playerList[position])}
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PlayerViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.adapter_player, parent, false)
        if(viewType==0){
            v.findViewById<CardView>(R.id.card_player_list).setCardBackgroundColor(Color.parseColor("#EAFFF3"))
        }else{
            v.findViewById<CardView>(R.id.card_player_list).setCardBackgroundColor(Color.parseColor("#D7FFE9"))
        }
        return PlayerViewHolder(v);
    }

    override fun getItemViewType(position: Int): Int {
        return position%2
    }

    override fun getItemCount(): Int {
        return playerList.size
    }

    internal class PlayerViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val dorsal = itemView.findViewById<TextView>(R.id.dorsal)
        val name = itemView.findViewById<TextView>(R.id.complete_name)
        val demarcation = itemView.findViewById<TextView>(R.id.demarcation)
    }

    fun setItems(items: MutableList<Player>) {
        playerList = items
    }

}