package com.jesuscb.footcoach.view.player

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.MenuItem
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Player
import com.jesuscb.footcoach.view.core.BaseActivity
import com.jesuscb.footcoach.view.core.IPlayerListToActivity
import kotlinx.android.synthetic.main.activity_player_add_to.*

class PlayerAddToActivity : BaseActivity(), IPlayerListToActivity {

    private lateinit var selectedPlayersIds: ArrayList<String>
    private var selectedPlayers: ArrayList<Player> = arrayListOf()
    var playerFragment: PlayerListFragment? = null

    companion object {

        private val ARG_PARAM_PLAYERS_SELECTED = "playerIDS"
        val RETURN_PARAM_PLAYERS_SELECTED: String = "selectedPlayerIDS"

        fun newIntent(context: Context, players: ArrayList<String>): Intent {
            val intent = Intent(context, PlayerAddToActivity::class.java)
            intent.putStringArrayListExtra(ARG_PARAM_PLAYERS_SELECTED, players)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_player_add_to)
        setSupportActionBar(add_player_to_activity_toolbar)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        selectedPlayersIds = intent.getStringArrayListExtra(ARG_PARAM_PLAYERS_SELECTED)
        playerFragment = PlayerListFragment.newInstanceSelectedPlayers(2, selectedPlayersIds)

        addFragment(playerFragment!!, list_players.id)
        btn_add_players.setOnClickListener { returnPlayersToDetailActivity() }
    }



    private fun returnPlayersToDetailActivity() {
        val returnIntent = Intent()
        selectedPlayers.addAll(playerFragment!!.getPlayersFromAdapter())
        returnIntent.putExtra(RETURN_PARAM_PLAYERS_SELECTED, selectedPlayers)
        setResult(Activity.RESULT_OK, returnIntent)
        finish()
    }

    override fun informPlayersIgnored(players: ArrayList<Player>) {
        selectedPlayers.addAll(players)
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        // Handle item selection
        backToDetails()
        return true
    }

    override fun onBackPressed() {
        backToDetails()
    }

    private fun backToDetails() {
        val returnIntent = Intent()
        setResult(Activity.RESULT_CANCELED, returnIntent)
        finish()
    }

    override fun deletePlayer(player: String) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun addPlayersToActivity(players: ArrayList<String>) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

}
