package com.jesuscb.footcoach.view.player

import android.graphics.Color
import android.support.v7.widget.CardView
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CheckBox
import android.widget.CompoundButton
import android.widget.TextView
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Player


internal class PlayerAddToAdapter(var playerList: MutableList<Player>, val playerListFragment: PlayerListFragment) : RecyclerView.Adapter<PlayerAddToAdapter.PlayerViewHolder>() {

    private var selectedPlayers: ArrayList<Player> = arrayListOf()

    override fun onBindViewHolder(holder: PlayerViewHolder, position: Int) {
        holder.dorsal.text = playerList[position].numDorsal.toString()
        holder.name.text = playerList[position].name.plus(" ").plus(playerList[position].surname)
        holder.demarcation.text = playerListFragment.getDemarcationValueFromKey(playerList[position].demarcation)

        holder.checkBox.setOnCheckedChangeListener(CompoundButton.OnCheckedChangeListener { _, isChecked ->
            if (isChecked) {
                selectedPlayers.add(playerList[position])
            } else {
                selectedPlayers.remove(playerList[position])
            }
        })
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PlayerViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.adapter_player_add_to, parent, false)
        if(viewType==0){
            v.findViewById<CardView>(R.id.card_player_add_to).setCardBackgroundColor(Color.parseColor("#EAFFF3"))
        }else{
            v.findViewById<CardView>(R.id.card_player_add_to).setCardBackgroundColor(Color.parseColor("#D7FFE9"))
        }
        return PlayerViewHolder(v);
    }

    override fun getItemViewType(position: Int): Int {
        return position%2
    }

    override fun getItemCount(): Int {
        return playerList.size
    }

    internal class PlayerViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val dorsal = itemView.findViewById<TextView>(R.id.dorsal)
        val name = itemView.findViewById<TextView>(R.id.complete_name)
        val demarcation = itemView.findViewById<TextView>(R.id.demarcation)
        val checkBox = itemView.findViewById<CheckBox>(R.id.checked)
    }

    fun setItems(items: MutableList<Player>) {
        playerList = items
    }

    fun getSelectedPlayers(): ArrayList<Player> {
        return selectedPlayers
    }

    fun removePlayersSelected(playerSelected: ArrayList<String>?) {
        playerList.removeAll { it -> playerSelected!!.contains(it.id_player) }
    }
}