package com.jesuscb.footcoach.view.player

import android.graphics.Color
import android.support.v7.widget.CardView
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Player

internal class PlayerDetailListAdapter(var playerList: MutableList<Player>, val playerListFragment: PlayerListFragment) : RecyclerView.Adapter<PlayerDetailListAdapter.PlayerViewHolder>() {

    override fun onBindViewHolder(holder: PlayerViewHolder, position: Int) {
        holder.dorsal.text = playerList[position].numDorsal.toString()
        holder.name.text = playerList[position].name.plus(" ").plus(playerList[position].surname)
        holder.demarcation.text = playerListFragment.getDemarcationValueFromKey(playerList[position].demarcation)

        holder.delete_btn.setOnClickListener { playerListFragment.deletePlayerFromTraining(playerList[position].id_player) }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PlayerViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.adapter_player_detail_training, parent, false)
        if(viewType==0){
            v.findViewById<CardView>(R.id.card_player_detail_training).setCardBackgroundColor(Color.parseColor("#EAFFF3"))
        }else{
            v.findViewById<CardView>(R.id.card_player_detail_training).setCardBackgroundColor(Color.parseColor("#D7FFE9"))
        }
        return PlayerViewHolder(v);
    }

    override fun getItemViewType(position: Int): Int {
        return position%2
    }

    override fun getItemCount(): Int {
        return playerList.size
    }

    internal class PlayerViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val dorsal = itemView.findViewById<TextView>(R.id.dorsal)
        val name = itemView.findViewById<TextView>(R.id.complete_name)
        val demarcation = itemView.findViewById<TextView>(R.id.demarcation)
        val delete_btn = itemView.findViewById<ImageView>(R.id.delete_btn)
    }

    fun setItems(items: MutableList<Player>) {
        playerList = items
    }

    fun addItem(item: Player) {
        playerList.add(item)
    }

    fun playersIds(): ArrayList<String> {
        return ArrayList(playerList.map { it.id_player }.toSet())
    }

}