package com.jesuscb.footcoach.view.training

import android.graphics.Color
import android.support.v7.widget.CardView
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.jesuscb.footcoach.R
import com.jesuscb.footcoach.model.Training
import com.jesuscb.footcoach.view.main.HomeFragment

internal class TrainingAdapterHome(var trainingList: MutableList<Training>, val homeFragment: HomeFragment) : RecyclerView.Adapter<TrainingAdapterHome.TrainingViewHolder>() {

    override fun onBindViewHolder(holder: TrainingViewHolder, position: Int) {
        holder.date.text = trainingList[position].date
        holder.schedule.text = trainingList[position].start_time.plus(" - ").plus(trainingList[position].end_time)

        holder.itemView.setOnClickListener { homeFragment.viewDetailsTraining(trainingList[position].id_training) }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TrainingViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.adapter_training, parent, false)
        if(viewType==0){
            v.findViewById<CardView>(R.id.card_training_list).setCardBackgroundColor(Color.parseColor("#FFFCE4"))
        }else{
            v.findViewById<CardView>(R.id.card_training_list).setCardBackgroundColor(Color.parseColor("#FFFACE"))
        }
        return TrainingViewHolder(v);
    }

    override fun getItemViewType(position: Int): Int {
        return position%2
    }

    override fun getItemCount(): Int {
        return trainingList.size
    }

    internal class TrainingViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val date = itemView.findViewById<TextView>(R.id.day_training)
        val schedule = itemView.findViewById<TextView>(R.id.schedule)

    }

    fun setItems(items: MutableList<Training>) {
        trainingList = items
    }
}